#include "VSensorLaser.h" 
#include <signal.h> 
#include <direct.h> 
#pragma comment(lib, "VSensorLaserSDK.lib")
using namespace std;
using namespace VSENSORLASER;
int main()
{
    //获取相对路径
    char cwd[200];
    if (_getcwd(cwd, 200) == nullptr)
    {
        printf("get path failed\n");
    }
    //实例化设备
    VSensorLaser* pVSensor = new VSensorLaser();
    //获取sdk版本
    string version = string();
    pVSensor->GetSdkVersionString(version);
    printf("sdk version: %s\n", version.c_str());
    //获取设备列表
    VSensorLaserCameraInfo cameraList[20];
    int num = 0;
    pVSensor->GetDeviceList(cameraList, &num);
    for (int i = 0; i < num; i++)
    {
        printf("device num %d : list[%d] = %s\n", i, i, cameraList[i].CameraName);
    }
    //连接设备，0为连接第一台设备  
    int status = pVSensor->DeviceConnect(0);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("connect device failed status = %d\n", status);
        system("pause");
    }
    //设置投影等级
    status = pVSensor->SetProjectLight(1);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set project light failed, status = %d\n", status);
        system("pause");
    }
    //设置曝光时间
    status = pVSensor->SetExposureTime(2.0);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set exposure time failed, status = %d\n", status);
        system("pause");
    }
    //设置为采集模式
    status = pVSensor->SetCaptureMode(emVSensorLaserCaptureMode::MODE_SOFT);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set capture mode failed, status = %d\n", status);
        system("pause");
    }
    //单次采集
    printf("start single capture...\n");
    VSensorLaserResult *pResult = new VSensorLaserResult;
    status = pVSensor->SingleRestruction(pResult, emVSensorLaserCaptureOutputMode::OUTPUT_MODE_ALL);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("single resturction failed, status = %d\n", status);
        system("pause");
    }
/*
    //读取VSensorLaserResult结构体获取无序点云
    for (int i = 0; i < pResult->ImageResolution.Width; i++)
    {
        if (pResult->mask[i])
        {
            //点云操作
            float x = pResult->pointx[i];
            float y = pResult->pointy[i];
            float z = pResult->pointz[i];
        }
    }
*/
    //保存无序点云为pcd格式
    status = pVSensor->Save3DCloud(string(cwd) + "//test.pcd", pResult, emVSensorLaserPointType::POINT_TYPR_DISORDER);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("save 3D points failed, status = %d\n", status);
        system("pause");
    }
    //保存原始灰度图
    status = pVSensor->SaveGrayMap(string(cwd) + "//gray.bmp", pResult);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("save gray image failed, status = %d\n", status);
        system("pause");
    }
    //设置为预览模式
    status = pVSensor->SetCaptureMode(emVSensorLaserCaptureMode::MODE_SPSOFT);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set capture mode failed, status = %d\n", status);
        system("pause");
    }
    //获取分辨率
    VSensorLaserImageResolution ImageResolution;
    status = pVSensor->GetImageResolution(&ImageResolution);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("get image resolution failed, status = %d\n", status);
        system("pause");
    }
    //获取2D图
    printf("start view capture...\n");
    unsigned char* gray = new unsigned char[ImageResolution.Width * ImageResolution.Height];
    status = pVSensor->CameraOut(gray);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("camera out failed, status = %d\n", status);
        system("pause");
    }
    //设置为采集模式
    status = pVSensor->SetCaptureMode(emVSensorLaserCaptureMode::MODE_SOFT);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set capture mode failed, status = %d\n", status);
        system("pause");
    }
    //点云录制
    status = pVSensor->Record3DCloud("test_record.pcd", emVSensorLaserRecordCloudMode::RECORD_DIS, 10);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set record 3D cloud failed, status = %d\n", status);
        system("pause");
    }
    //连续采集
    printf("start continuous capture...\n");
    pVSensor->ContinuousRestructionStart(emVSensorLaserCaptureOutputMode::OUTPUT_MODE_ALL);
    for (int i = 0; i < 10; i++)
    {
        status = pVSensor->CaptureFrame(pResult, 1000);
        if (status != CAMERA_STATUS_SUCCESS)
        {
            printf("capture frame failed, status = %d\n", status);
        }
        else
        {
            printf("%d  num =  %d\n", i + 1, pResult->nPointNum);
            string str(string(cwd) + "//test" + to_string(i + 1) + ".pcd");
            status = pVSensor->Save3DCloud(str, pResult, emVSensorLaserPointType::POINT_TYPR_DISORDER);
            if (status != CAMERA_STATUS_SUCCESS)
            {
                printf("save 3D points failed, status = %d\n", status);
                system("pause");
            }
        }
    }
    pVSensor->ContinuousRestructionStop();
    //获取录制点云
    std::vector<std::array<float, 3>> cloud;
    status = pVSensor->GetRecord3DCloud(cloud);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("get record 3D cloud failed, status = %d\n", status);
        system("pause");
    }
    //反初始化设备
    status = pVSensor->DeviceUnInit();
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("device release failed, status = %d\n", status);
        system("pause");
    }
    delete pResult;
    delete pVSensor;
    printf("run success\n");
    system("pause");
    return 0;
}